#!/home/moerman/cadbin/perl -w
# Interactive Interpreter
# Reads and interprets entered Perl statements
# C.M. Moerman, 1 feb 1998
# Adapted for UNIX 10 mar 1998

print "Hello, world. This is Perl 5.\n";
print "Type 'quit' to stop..\nPerl> ";

$LOGFILE = "logfile";
$log_on = 1;				# logging?

unlink "$LOGFILE.old";
if ($^O =~ /Win32/i)
{
    system "copy $LOGFILE.pl $LOGFILE.old >nul:" if -f "$LOGFILE.pl";
}
else
{
    system "cp $LOGFILE.pl $LOGFILE.old > /dev/null" if -f "$LOGFILE.pl";
}

if(!open (LOGFILE, ">$LOGFILE.pl"))     # log all statements
{       print STDERR "Can't open logfile $LOGFILE\n";
	$log_on = 0;
}
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
$mon++;
print LOGFILE "#logfile created $hour:$min $mday/$mon/$year\n" if $log_on;
$sec .= $wday . $yday . $isdst;         # suppress warning

$, = ", ";                              # list separator

while(<>)
{
        last if (/^quit/i);             # 'quit'stops interpret loop
        s/^\?/print /;
        while (/\\$/)                   # \ at end of line indicates
        {                               # line continuation
                s/\\$//;                # so chop '\'
                $_ .= <>;               # and glue next line
        }
        print LOGFILE $_ if $log_on;    # output to log file for reuse

        @result = eval;                 # evaluate entered expression

        print " eval returned: " if !/^print/;
        print @result if !/^print/;     # only print if statement didn't
        print $@ if ($@);               # Any error messages generated?

        print "\nPerl> ";               # print prompt
}

print "\n Bye Bye..\n";

close LOGFILE;

# end of perl script

